#!/usr/gnu/bin/perl --		# -*- perl -*-

$rotlog_rcsId = ' $Id: rotlog.pl,v 1.3 1995/09/15 23:10:42 bellman Exp $ ';

$generations = 5;

while ($_ = $ARGV[0]) {
    if (/^-/) {
	option($_) and next;
    }

    rotate_file($_, $generations);

} continue {
    shift;
}



sub rotate_file
{
    my($filename) = shift;
    my($nversions) = shift;

    my($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size,
       $atime, $mtime, $ctime, $blksize, $blocks) = stat($filename);

    if ($minimum_size  &&  $size < $minimum_size) {
	return; }
    if ($minimum_lines  &&  `wc -l "$filename"` < $minimum_lines) {
	return; }

    while (--$nversions >= 0) {
	my($oldname) = $nversions > 0 ? "$filename.$nversions" : $filename;
	my($newname) = $filename.".".($nversions+1);
	(rename($oldname, $newname)
	 and $verbose ? print("$oldname -> $newname\n") : 1)
	    or (rename("$oldname.gz", "$newname.gz")
		and $verbose ? print("$oldname.gz -> $newname.gz\n") : 1);
    }

    system("gzip ". ($verbose && "-v ") ."'$filename.2'")
	if (-f "$filename.2");
    open(NEWFILE, ">$filename");
    chown($uid, $gid, $filename);
    chmod($mode, $filename);
    close(NEWFILE);
}




sub option
{
    my($opt) = $_[0];
    my($longname, $shortname, $optval);

    return 0  if $option__no_more_options;
    if ($opt eq "--") {
	$option__no_more_options = 1;
	return 1;
    }

    if ($opt =~ /^--(.+)=(.*)/) {
	$longname = $1;
	$optval = $2;
    } elsif ($opt =~ /^--(.+)/) {
	$longname = $1;
	$optval = "";
    } elsif ($opt =~ /^-(.?)(.*)/) {
	$shortname = $1;
	$optval = $2;
    } elsif ($opt =~ /^-(.?)$/) {
	$shortname = $1;
	$optval = "";
    }

    if ($longname eq "generations"  ||  $shortname eq "g") {
	if ($optval !~ /^[0-9]+$/) {
	    die "Generations option must be numeric\n";
	}
	$generations = $optval;
    } elsif ($longname eq "verbose"  ||  $shortname eq "v") {
	$verbose = 1;
    } elsif ($longname eq "file"  ||  $shortname eq "f") {
	$_ = $optval;
	return 0;
    } elsif ($longname eq "minsize"  ||  $shortname eq "s") {
	if ($optval !~ /^([0-9]+)([bkml]?)$/) {
	    die "Minsize option must be numeric\n";
	}
	$minimum_size = $1;
	if    ($2 eq "b") { $minimum_size *=     512; }
	elsif ($2 eq "k") { $minimum_size *=    1024; }
	elsif ($2 eq "m") { $minimum_size *= 1048576; }
	elsif ($2 eq "l") { $minimum_lines = $1; $minimum_size = ""; }
    }

    return 1;
}
